/* Connect.cpp - MyopicTopics.com Addin - part 3
 * Written By: Jason Weiler
 * This code is in the public domain
 */

// Connect.cpp : Implementation of CConnect
#include "stdafx.h"
#include "AddIn.h"
#include "Connect.h"

extern CAddInModule _AtlModule;

// CConnect
STDMETHODIMP CConnect::OnConnection(IDispatch *pApplication, ext_ConnectMode ConnectMode, IDispatch *pAddInInst, SAFEARRAY ** /*custom*/ )
{
	// unused variables
	(void)ConnectMode;

	HRESULT hr = S_OK;
	pApplication->QueryInterface(__uuidof(DTE2), (LPVOID*)&m_pDTE);
	pAddInInst->QueryInterface(__uuidof(AddIn), (LPVOID*)&m_pAddInInstance);

	if ( !m_pDTE || !m_pAddInInstance)
	{
		// This should never happen, but we don't want this add-in running if it does.
		return E_FAIL;
	}

//*** Hooking debugger events ***/
	// Register the OnEnterBreakMode handler
	if ( !m_pDebuggerEvents )
	{
		CComPtr<EnvDTE::Events> spEvents;
		m_pDTE->get_Events(&spEvents);
		if (spEvents->get_DebuggerEvents(&m_pDebuggerEvents) == S_OK)
		{
			// Attach to the debugger events
			hr = ConnectDebuggerEvents::DispEventAdvise(m_pDebuggerEvents);
		}
	}
//*** Hooking debugger events ***/

	return hr;
}

STDMETHODIMP CConnect::OnDisconnection(ext_DisconnectMode /*RemoveMode*/, SAFEARRAY ** /*custom*/ )
{
//*** Hooking debugger events ***/
	// Register the OnEnterBreakMode handler
	if (m_pDebuggerEvents)
	{
		// Let go of the debugger events
		ConnectDebuggerEvents::DispEventUnadvise(m_pDebuggerEvents);
	}
//*** Hooking debugger events ***/

	// Explicitly set these to NULL because our object may not be completely going away.
	// These are CComPtr template types, so setting them to NULL calls Release automatically.
	m_pDebuggerEvents = NULL;
	m_pDTE = NULL;
	m_pAddInInstance = NULL;

	return S_OK;
}

STDMETHODIMP CConnect::OnAddInsUpdate (SAFEARRAY ** /*custom*/ )
{
	return S_OK;
}

STDMETHODIMP CConnect::OnStartupComplete (SAFEARRAY ** /*custom*/ )
{
	return S_OK;
}

STDMETHODIMP CConnect::OnBeginShutdown (SAFEARRAY ** /*custom*/ )
{
	return S_OK;
}

//*** Hooking debugger events ***/
STDMETHODIMP CConnect::OnEnterBreakMode(EnvDTE::dbgEventReason Reason, EnvDTE::dbgExecutionAction* ExecutionAction)
{
	// unused variables
	(void)ExecutionAction;
	(void)Reason;


	CComPtr<EnvDTE::Debugger> pDebugger = NULL;
	if (m_pDTE)
	{
		m_pDTE->get_Debugger(&pDebugger);

		// TODO: Use the debugger object to get what we want to know about the target process.
	}

	return S_OK;
}
//*** Hooking debugger events ***/
